using C1.Win.FlexGrid;
using System.Diagnostics;
using System.Reflection;
using System.Runtime.InteropServices;

namespace AutomationProviderTest611
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();

      this.Refill();
    }

    private void c1FlexGrid1_DoubleClick(object sender, EventArgs e)
    {
      //This might cause the error, see "OnSelChange": the Automation event is only raised, if "ContainsFocus"
      //this.Refill();


      //Use a different filling apporach: reset the cols count. Row count is kept.
      try
      {
        this.c1FlexGrid1.BeginUpdate();

        this.c1FlexGrid1.Cols.Count = this.c1FlexGrid1.Cols.Fixed;
        this.c1FlexGrid1.Cols.Count = 1;

        DateTime now = DateTime.Now;
        for (int i = 0; i < 20; i++)
        {
          this.c1FlexGrid1[i, 0] = "Row " + i + " (" + now + ")";
        }

        this.c1FlexGrid1.EndUpdate();
      }
      catch (Exception ex)
      {
        //Trace.Write(ex);
        string s = "ERROR: " + ex.Message + " (" + ex.GetType().FullName + ")" + Environment.NewLine + ex.StackTrace;
        Clipboard.SetData(DataFormats.Text, s);
        //MessageBox.Show(this, "ERROR: " + ex.Message + " (" + ex.GetType().FullName + ")" + Environment.NewLine + ex.StackTrace);
        MessageBox.Show(this, s);
      }

    }

    private void Refill()
    {
      try
      {
        this.c1FlexGrid1.BeginUpdate();

        this.c1FlexGrid1.Rows.Count = this.c1FlexGrid1.Rows.Fixed;
        this.c1FlexGrid1.Rows.Count = 20;
        DateTime now = DateTime.Now;
        for (int i = 0; i < 20; i++)
        {
          this.c1FlexGrid1[i, 0] = "Row " + i + " (" + now + ")";
        }

        this.c1FlexGrid1.EndUpdate();

      }
      catch (Exception ex)
      {
        MessageBox.Show(this, "ERROR: " + ex.Message + " (" + ex.GetType().FullName + ")" + Environment.NewLine + ex.StackTrace);
      }
    }
  }
}